diff --git a/sys/contrib/dev/acpica/source/tools/acpiexec/aetables.c b/sys/contrib/dev/acpica/source/tools/acpiexec/aetables.c
index de51b210df..c16033554f 100644
--- a/sys/contrib/dev/acpica/source/tools/acpiexec/aetables.c
+++ b/sys/contrib/dev/acpica/source/tools/acpiexec/aetables.c
@@ -220,14 +220,14 @@ AeTableOverride (
 
     /* This code exercises the table override mechanism in the core */
 
-    if (ACPI_COMPARE_NAME (ExistingTable->Signature, ACPI_SIG_DSDT))
+    if (ACPI_COMPARE_NAMESEG (ExistingTable->Signature, ACPI_SIG_DSDT))
     {
         *NewTable = DsdtToInstallOverride;
     }
 
     /* This code tests override of dynamically loaded tables */
 
-    else if (ACPI_COMPARE_NAME (ExistingTable->Signature, "OEM9"))
+    else if (ACPI_COMPARE_NAMESEG (ExistingTable->Signature, "OEM9"))
     {
         *NewTable = ACPI_CAST_PTR (ACPI_TABLE_HEADER, Ssdt3Code);
     }
@@ -255,13 +255,13 @@ AeInitializeTableHeader (
     UINT32                  Length)
 {
 
-    ACPI_MOVE_NAME (Header->Signature, Signature);
+    ACPI_COPY_NAMESEG (Header->Signature, Signature);
     Header->Length = Length;
 
     Header->OemRevision = 0x1001;
     memcpy (Header->OemId, "Intel ", ACPI_OEM_ID_SIZE);
     memcpy (Header->OemTableId, "AcpiExec", ACPI_OEM_TABLE_ID_SIZE);
-    ACPI_MOVE_NAME (Header->AslCompilerId, "INTL");
+    ACPI_COPY_NAMESEG (Header->AslCompilerId, "INTL");
     Header->AslCompilerRevision = ACPI_CA_VERSION;
 
     /* Set the checksum, must set to zero first */
@@ -306,8 +306,8 @@ AeBuildLocalTables (
     NextTable = ListHead;
     while (NextTable)
     {
-        if (!ACPI_COMPARE_NAME (NextTable->Table->Signature, ACPI_SIG_DSDT) &&
-            !ACPI_COMPARE_NAME (NextTable->Table->Signature, ACPI_SIG_FADT))
+        if (!ACPI_COMPARE_NAMESEG (NextTable->Table->Signature, ACPI_SIG_DSDT) &&
+            !ACPI_COMPARE_NAMESEG (NextTable->Table->Signature, ACPI_SIG_FADT))
         {
             TableCount++;
         }
@@ -345,7 +345,7 @@ AeBuildLocalTables (
          * Incoming DSDT or FADT are special cases. All other tables are
          * just immediately installed into the XSDT.
          */
-        if (ACPI_COMPARE_NAME (NextTable->Table->Signature, ACPI_SIG_DSDT))
+        if (ACPI_COMPARE_NAMESEG (NextTable->Table->Signature, ACPI_SIG_DSDT))
         {
             if (DsdtAddress)
             {
@@ -358,7 +358,7 @@ AeBuildLocalTables (
             DsdtAddress = ACPI_PTR_TO_PHYSADDR (NextTable->Table);
             DsdtToInstallOverride = NextTable->Table;
         }
-        else if (ACPI_COMPARE_NAME (NextTable->Table->Signature, ACPI_SIG_FADT))
+        else if (ACPI_COMPARE_NAMESEG (NextTable->Table->Signature, ACPI_SIG_FADT))
         {
             ExternalFadt = ACPI_CAST_PTR (ACPI_TABLE_FADT, NextTable->Table);
             LocalXSDT->TableOffsetEntry[0] = ACPI_PTR_TO_PHYSADDR (NextTable->Table);
@@ -531,7 +531,7 @@ AeBuildLocalTables (
     /* Build a FACS */
 
     memset (&LocalFACS, 0, sizeof (ACPI_TABLE_FACS));
-    ACPI_MOVE_NAME (LocalFACS.Signature, ACPI_SIG_FACS);
+    ACPI_COPY_NAMESEG (LocalFACS.Signature, ACPI_SIG_FACS);
 
     LocalFACS.Length = sizeof (ACPI_TABLE_FACS);
     LocalFACS.GlobalLock = 0x11AA0011;
@@ -545,7 +545,7 @@ AeBuildLocalTables (
          * ACPICA core ignores it
          */
         memset (&LocalTEST, 0, sizeof (ACPI_TABLE_HEADER));
-        ACPI_MOVE_NAME (LocalTEST.Signature, "TEST");
+        ACPI_COPY_NAMESEG (LocalTEST.Signature, "TEST");
 
         LocalTEST.Revision = 1;
         LocalTEST.Length = sizeof (ACPI_TABLE_HEADER);
@@ -559,7 +559,7 @@ AeBuildLocalTables (
          * sure that the ACPICA core ignores it
          */
         memset (&LocalBADTABLE, 0, sizeof (ACPI_TABLE_HEADER));
-        ACPI_MOVE_NAME (LocalBADTABLE.Signature, "BAD!");
+        ACPI_COPY_NAMESEG (LocalBADTABLE.Signature, "BAD!");
 
         LocalBADTABLE.Revision = 1;
         LocalBADTABLE.Length = sizeof (ACPI_TABLE_HEADER);
diff --git a/sys/contrib/dev/acpica/source/tools/acpiexec/aetests.c b/sys/contrib/dev/acpica/source/tools/acpiexec/aetests.c
index 9f66fcea4e..9f35e8f5ac 100644
--- a/sys/contrib/dev/acpica/source/tools/acpiexec/aetests.c
+++ b/sys/contrib/dev/acpica/source/tools/acpiexec/aetests.c
@@ -168,6 +168,10 @@ static void
 AeTestSleepData (
     void);
 
+static void
+AeGlobalAddressRangeCheck(
+    void);
+
 
 /******************************************************************************
  *
@@ -594,3 +598,59 @@ AeTestSleepData (
         }
     }
 }
+
+
+/******************************************************************************
+ *
+ * FUNCTION:    AeLateTest
+ *
+ * DESCRIPTION: Exercise tests that should be performed before shutdown.
+ *
+ *****************************************************************************/
+
+void
+AeLateTest (
+    void)
+{
+    AeGlobalAddressRangeCheck();
+}
+
+
+/******************************************************************************
+ *
+ * FUNCTION:    AeGlobalAddressRangeCheck
+ *
+ * DESCRIPTION: There have been some issues in the past with adding and
+ *              removing items to the global address list from
+ *              OperationRegions declared in control methods. This test loops
+ *              over the list to ensure that dangling pointers do not exist in
+ *              the global address list.
+ *
+ *****************************************************************************/
+
+static void
+AeGlobalAddressRangeCheck(
+    void)
+{
+    ACPI_STATUS             Status;
+    ACPI_ADDRESS_RANGE      *Current;
+    ACPI_BUFFER             ReturnBuffer;
+    UINT32                  i;
+
+
+    ReturnBuffer.Length = ACPI_ALLOCATE_BUFFER;
+    AcpiUtInitializeBuffer (&ReturnBuffer, ACPI_ALLOCATE_BUFFER);
+
+    for (i = 0; i < ACPI_ADDRESS_RANGE_MAX; i++)
+    {
+        Current = AcpiGbl_AddressRangeList[i];
+
+        while (Current)
+        {
+            Status = AcpiGetName (Current->RegionNode, ACPI_SINGLE_NAME, &ReturnBuffer);
+            ACPI_CHECK_OK (AcpiGetname, Status);
+
+            Current = Current->Next;
+        }
+    }
+}
diff --git a/sys/contrib/dev/acpica/source/tools/acpihelp/ahdecode.c b/sys/contrib/dev/acpica/source/tools/acpihelp/ahdecode.c
index 025246b722..13b72d6bb1 100644
--- a/sys/contrib/dev/acpica/source/tools/acpihelp/ahdecode.c
+++ b/sys/contrib/dev/acpica/source/tools/acpihelp/ahdecode.c
@@ -297,7 +297,7 @@ AhFindPredefinedNames (
 {
     UINT32                  Length;
     BOOLEAN                 Found;
-    char                    Name[ACPI_NAME_SIZE + 1];
+    char                    Name[ACPI_NAMESEG_SIZE + 1];
 
 
     if (!NamePrefix || (*NamePrefix == '*'))
@@ -307,7 +307,7 @@ AhFindPredefinedNames (
     }
 
     Length = strlen (NamePrefix);
-    if (Length > ACPI_NAME_SIZE)
+    if (Length > ACPI_NAMESEG_SIZE)
     {
         printf ("%.8s: Predefined name must be 4 characters maximum\n",
             NamePrefix);
diff --git a/sys/contrib/dev/acpica/source/tools/acpinames/antables.c b/sys/contrib/dev/acpica/source/tools/acpinames/antables.c
index 911a2cc5c2..289948f68a 100644
--- a/sys/contrib/dev/acpica/source/tools/acpinames/antables.c
+++ b/sys/contrib/dev/acpica/source/tools/acpinames/antables.c
@@ -206,13 +206,13 @@ AnInitializeTableHeader (
     UINT32                  Length)
 {
 
-    ACPI_MOVE_NAME (Header->Signature, Signature);
+    ACPI_COPY_NAMESEG (Header->Signature, Signature);
     Header->Length = Length;
 
     Header->OemRevision = 0x1001;
     memcpy (Header->OemId, "Intel ", ACPI_OEM_ID_SIZE);
     memcpy (Header->OemTableId, "AcpiExec", ACPI_OEM_TABLE_ID_SIZE);
-    ACPI_MOVE_NAME (Header->AslCompilerId, "INTL");
+    ACPI_COPY_NAMESEG (Header->AslCompilerId, "INTL");
     Header->AslCompilerRevision = ACPI_CA_VERSION;
 
     /* Set the checksum, must set to zero first */
@@ -257,8 +257,8 @@ AnBuildLocalTables (
     NextTable = TableList;
     while (NextTable)
     {
-        if (!ACPI_COMPARE_NAME (NextTable->Table->Signature, ACPI_SIG_DSDT) &&
-            !ACPI_COMPARE_NAME (NextTable->Table->Signature, ACPI_SIG_FADT))
+        if (!ACPI_COMPARE_NAMESEG (NextTable->Table->Signature, ACPI_SIG_DSDT) &&
+            !ACPI_COMPARE_NAMESEG (NextTable->Table->Signature, ACPI_SIG_FADT))
         {
             TableCount++;
         }
@@ -294,7 +294,7 @@ AnBuildLocalTables (
          * Incoming DSDT or FADT are special cases. All other tables are
          * just immediately installed into the XSDT.
          */
-        if (ACPI_COMPARE_NAME (NextTable->Table->Signature, ACPI_SIG_DSDT))
+        if (ACPI_COMPARE_NAMESEG (NextTable->Table->Signature, ACPI_SIG_DSDT))
         {
             if (DsdtAddress)
             {
@@ -306,7 +306,7 @@ AnBuildLocalTables (
 
             DsdtAddress = ACPI_PTR_TO_PHYSADDR (NextTable->Table);
         }
-        else if (ACPI_COMPARE_NAME (NextTable->Table->Signature, ACPI_SIG_FADT))
+        else if (ACPI_COMPARE_NAMESEG (NextTable->Table->Signature, ACPI_SIG_FADT))
         {
             ExternalFadt =
                 ACPI_CAST_PTR (ACPI_TABLE_FADT, NextTable->Table);
@@ -434,7 +434,7 @@ AnBuildLocalTables (
     /* Build a FACS */
 
     memset (&LocalFACS, 0, sizeof (ACPI_TABLE_FACS));
-    ACPI_MOVE_NAME (LocalFACS.Signature, ACPI_SIG_FACS);
+    ACPI_COPY_NAMESEG (LocalFACS.Signature, ACPI_SIG_FACS);
 
     LocalFACS.Length = sizeof (ACPI_TABLE_FACS);
     LocalFACS.GlobalLock = 0x11AA0011;
diff --git a/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.c b/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.c
index ef679ba115..4afdeeca69 100644
--- a/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.c
+++ b/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.c
@@ -204,7 +204,7 @@ AxExtractTables (
 
     if (Signature)
     {
-        strncpy (UpperSignature, Signature, ACPI_NAME_SIZE);
+        strncpy (UpperSignature, Signature, ACPI_NAMESEG_SIZE);
         AcpiUtStrupr (UpperSignature);
 
         /* Are there enough instances of the table to continue? */
@@ -262,12 +262,12 @@ AxExtractTables (
                 continue;
             }
 
-            ACPI_MOVE_NAME (ThisSignature, Gbl_LineBuffer);
+            ACPI_COPY_NAMESEG (ThisSignature, Gbl_LineBuffer);
             if (Signature)
             {
                 /* Ignore signatures that don't match */
 
-                if (!ACPI_COMPARE_NAME (ThisSignature, UpperSignature))
+                if (!ACPI_COMPARE_NAMESEG (ThisSignature, UpperSignature))
                 {
                     continue;
                 }
@@ -466,12 +466,12 @@ AxExtractToMultiAmlFile (
                 continue;
             }
 
-            ACPI_MOVE_NAME (ThisSignature, Gbl_LineBuffer);
+            ACPI_COPY_NAMESEG (ThisSignature, Gbl_LineBuffer);
 
             /* Only want DSDT and SSDTs */
 
-            if (!ACPI_COMPARE_NAME (ThisSignature, ACPI_SIG_DSDT) &&
-                !ACPI_COMPARE_NAME (ThisSignature, ACPI_SIG_SSDT))
+            if (!ACPI_COMPARE_NAMESEG (ThisSignature, ACPI_SIG_DSDT) &&
+                !ACPI_COMPARE_NAMESEG (ThisSignature, ACPI_SIG_SSDT))
             {
                 continue;
             }
diff --git a/sys/contrib/dev/acpica/source/tools/acpixtract/axutils.c b/sys/contrib/dev/acpica/source/tools/acpixtract/axutils.c
index 07d48b67cf..480bd0f328 100644
--- a/sys/contrib/dev/acpica/source/tools/acpixtract/axutils.c
+++ b/sys/contrib/dev/acpica/source/tools/acpixtract/axutils.c
@@ -530,7 +530,7 @@ AxCountTableInstances (
         }
 
         AxNormalizeSignature (Gbl_InstanceBuffer);
-        if (ACPI_COMPARE_NAME (Gbl_InstanceBuffer, Signature))
+        if (ACPI_COMPARE_NAMESEG (Gbl_InstanceBuffer, Signature))
         {
             Instances++;
         }
@@ -703,7 +703,7 @@ AxDumpTableHeader (
 
     /* FACS has only signature and length */
 
-    if (ACPI_COMPARE_NAME (TableHeader->Signature, "FACS"))
+    if (ACPI_COMPARE_NAMESEG (TableHeader->Signature, "FACS"))
     {
         printf ("  0x%2.2X\n", Facs->Version);
         return;
@@ -745,7 +745,7 @@ AxCheckTableLengths (
     }
 
     if ((ByteCount < sizeof (ACPI_TABLE_HEADER)) &&
-        (ByteCount >= ACPI_NAME_SIZE))
+        (ByteCount >= ACPI_NAMESEG_SIZE))
     {
         printf ("  : (Table too short for an ACPI table)");
     }
diff --git a/sys/dev/acpica/Osd/OsdTable.c b/sys/dev/acpica/Osd/OsdTable.c
index bdcc41ad60..dcf032fd19 100644
--- a/sys/dev/acpica/Osd/OsdTable.c
+++ b/sys/dev/acpica/Osd/OsdTable.c
@@ -50,7 +50,7 @@ AcpiOsPredefinedOverride (
 	return (AE_BAD_PARAMETER);
 
     *NewVal = NULL;
-    if (ACPI_COMPARE_NAME(InitVal->Name, "_OS_") &&
+    if (ACPI_COMPARE_NAMESEG(InitVal->Name, "_OS_") &&
 	InitVal->Type == ACPI_TYPE_STRING && strlen(acpi_osname) > 0) {
 	kprintf("ACPI: Overriding _OS definition with \"%s\"\n", acpi_osname);
 	*NewVal = acpi_osname;
@@ -70,7 +70,7 @@ AcpiOsTableOverride (
 	return(AE_BAD_PARAMETER);
 
     *NewTable = NULL;
-    if (ACPI_COMPARE_NAME(ExistingTable->Signature, ACPI_SIG_DSDT) == 0)
+    if (ACPI_COMPARE_NAMESEG(ExistingTable->Signature, ACPI_SIG_DSDT) == 0)
 	return(AE_SUPPORT);
     if ((acpi_dsdt = preload_search_by_type("acpi_dsdt")) == NULL)
 	return(AE_NOT_FOUND);
diff --git a/sys/dev/acpica/acpi_quirk.c b/sys/dev/acpica/acpi_quirk.c
index f40e69b675..cc25c30c0f 100644
--- a/sys/dev/acpica/acpi_quirk.c
+++ b/sys/dev/acpica/acpi_quirk.c
@@ -48,7 +48,7 @@ enum val_t {
 };
 
 struct acpi_q_rule {
-    char	sig[ACPI_NAME_SIZE];	/* Table signature to match */
+    char	sig[ACPI_NAMESEG_SIZE];	/* Table signature to match */
     enum val_t	val;
     union {
 	char	*id;
@@ -157,11 +157,11 @@ acpi_table_quirks(int *quirks)
     for (entry = acpi_quirks_table; entry->match; entry++) {
 	done = TRUE;
 	for (match = entry->match; match->sig[0] != '\0'; match++) {
-	    if (ACPI_COMPARE_NAME(match->sig, "FADT"))
+	    if (ACPI_COMPARE_NAMESEG(match->sig, "FADT"))
 		hdr = &fadt;
-	    else if (ACPI_COMPARE_NAME(match->sig, ACPI_SIG_DSDT))
+	    else if (ACPI_COMPARE_NAMESEG(match->sig, ACPI_SIG_DSDT))
 		hdr = &dsdt;
-	    else if (ACPI_COMPARE_NAME(match->sig, ACPI_SIG_XSDT))
+	    else if (ACPI_COMPARE_NAMESEG(match->sig, ACPI_SIG_XSDT))
 		hdr = &xsdt;
 	    else
 		panic("invalid quirk header\n");
diff --git a/sys/platform/pc64/acpica/acpi_sdt.c b/sys/platform/pc64/acpica/acpi_sdt.c
index 6245e4437a..fa894a0e3e 100644
--- a/sys/platform/pc64/acpica/acpi_sdt.c
+++ b/sys/platform/pc64/acpica/acpi_sdt.c
@@ -175,7 +175,7 @@ sdt_search_xsdt(vm_paddr_t xsdt_paddr, const uint8_t *sig)
 	}
 
 	if (memcmp(xsdt->Header.Signature, ACPI_SIG_XSDT,
-		   ACPI_NAME_SIZE) != 0) {
+		   ACPI_NAMESEG_SIZE) != 0) {
 		kprintf("sdt_search_xsdt: not XSDT\n");
 		goto back;
 	}
@@ -203,7 +203,7 @@ sdt_search_xsdt(vm_paddr_t xsdt_paddr, const uint8_t *sig)
 		if (sdth != NULL) {
 			int ret;
 
-			ret = memcmp(sdth->Signature, sig, ACPI_NAME_SIZE);
+			ret = memcmp(sdth->Signature, sig, ACPI_NAMESEG_SIZE);
 			sdt_sdth_unmap(sdth);
 
 			if (ret == 0) {
@@ -236,7 +236,7 @@ sdt_search_rsdt(vm_paddr_t rsdt_paddr, const uint8_t *sig)
 	}
 
 	if (memcmp(rsdt->Header.Signature, ACPI_SIG_RSDT,
-		   ACPI_NAME_SIZE) != 0) {
+		   ACPI_NAMESEG_SIZE) != 0) {
 		kprintf("sdt_search_rsdt: not RSDT\n");
 		goto back;
 	}
@@ -264,7 +264,7 @@ sdt_search_rsdt(vm_paddr_t rsdt_paddr, const uint8_t *sig)
 		if (sdth != NULL) {
 			int ret;
 
-			ret = memcmp(sdth->Signature, sig, ACPI_NAME_SIZE);
+			ret = memcmp(sdth->Signature, sig, ACPI_NAMESEG_SIZE);
 			sdt_sdth_unmap(sdth);
 
 			if (ret == 0) {
-- 
2.21.0

